<template>
  <div
    data-component-group="user-form"
    data-component="add-new"
  >
    <form @:submit.prevent="onSubmit">
      <v-flex xs12>
        <v-layout>
          <v-flex xs6>
            <v-text-field
              v-model="firstName"
              prepend-inner-icon="account_box"
              :label="$t('components.forms.user_profile.first_name_placeholder')"
              required
              type="text"
              :readonly="isDisabled"
              :autofocus="true"
              :error-messages="firstNameErrors"
              @blur="$v.firstName.$touch()"
            />
          </v-flex>
          <v-flex xs6>
            <v-text-field
              v-model="lastName"
              prepend-inner-icon="contacts"
              :label="$t('components.forms.user_profile.last_name_placeholder')"
              required
              type="text"
              :readonly="isDisabled"
              :error-messages="lastNameErrors"
              @blur="$v.lastName.$touch()"
            />
          </v-flex>
        </v-layout>
      </v-flex>

      <v-text-field
        v-model="title"
        prepend-inner-icon="bookmark_border"
        :label="$t('components.forms.user_profile.title_placeholder')"
        required
        type="text"
        :readonly="isDisabled"
        :error-messages="titleErrors"
        @blur="$v.title.$touch()"
      />

      <v-text-field
        v-model="email"
        :label="$t('components.forms.user_profile.email_placeholder')"
        prepend-inner-icon="email"
        required
        type="text"
        :readonly="isDisabled"
        :error-messages="emailErrors"
        @blur="$v.email.$touch()"
      />

      <v-flex>
        <v-layout>
          <v-flex xs6>
            <v-autocomplete
              v-model="role"
              :items="roles"
              :filter="customFilter"
              label="Role"
              item-text="name"
              item-value="code"
              :return-object="true"
              required
              :readonly="isSuperAdmin || isDisabled"
              :error-messages="roleErrors"
              prepend-inner-icon="contacts"
              :menu-props="{nudgeBottom:'10'}"
              @blur="$v.role.$touch()"
            />
          </v-flex>
          <v-flex xs6>
            <Can
              I="see-business-account-owner"
              a="user"
            >
              <v-autocomplete
                v-if="isBusinessContact"
                v-model="business"
                :items="businesses"
                :filter="customFilter"
                :loading="isLoadingBusinesses"
                prepend-inner-icon="contacts"
                label="Business"
                item-text="name"
                item-value="id"
                :return-object="true"
                required
                :readonly="isDisabled"
                :error-messages="businessErrors"
                :menu-props="{nudgeBottom:'10'}"
                :search-input.sync="businessSearch"
                @blur="$v.business.$touch()"
              />
            </Can>
            <v-autocomplete
              v-if="(!hasUser && !isBusinessContact && $v.role.$dirty) || (hasUser && !isBusinessContact)"
              v-model="selectedCountries"
              :items="countries"
              :filter="customFilter"
              :multiple="true"
              prepend-inner-icon="public"
              label="Country"
              item-text="name"
              item-value="code"
              :return-object="true"
              required
              :readonly="isSuperAdmin || isDisabled"
              :menu-props="{nudgeBottom:'10'}"
              :error-messages="countryErrors"
              @blur="$v.selectedCountries.$touch()"
            />
          </v-flex>
        </v-layout>
      </v-flex>

      <v-flex xs12>
        <v-layout>
          <v-flex xs6>
            <v-autocomplete
              v-model="language"
              :items="languages"
              :filter="customFilter"
              prepend-inner-icon="language"
              label="Language"
              item-text="name"
              item-value="code"
              :return-object="true"
              required
              :readonly="isDisabled"
              :error-messages="languageErrors"
              :menu-props="{nudgeBottom:'10'}"
              @blur="$v.language.$touch()"
            />
          </v-flex>
          <v-flex xs6>
            <v-autocomplete
              v-model="timezone"
              :items="timezones"
              :filter="customFilter"
              prepend-inner-icon="schedule"
              label="Timezone"
              item-text="name"
              item-value="code"
              :return-object="true"
              required
              :readonly="isDisabled"
              :error-messages="timezoneErrors"
              :menu-props="{nudgeBottom:'10'}"
              @blur="$v.timezone.$touch()"
            />
          </v-flex>
        </v-layout>
      </v-flex>

      <div class="form-actions">
        <v-btn
          v-if="onCancel"
          color="secondary"
          depressed
          @click="cancel"
        >
          {{ cancelTriggerLabel }}
        </v-btn>
        <v-btn
          v-if="onSubmit && !isDisabled"
          color="primary"
          class="trigger"
          depressed
          :loading="isLoading"
          @click="submit"
        >
          <v-icon>
            {{ submitTriggerIcon }}
          </v-icon>
          {{ confirmTriggerLabel }}
        </v-btn>
      </div>
    </form>
  </div>
</template>

<script>
  import { validationMixin } from 'vuelidate';
  import { required, email } from 'vuelidate/lib/validators';
  import colors from 'vuetify/es5/util/colors';
  import router from '../../../router';
  import { isStr, isNum, isObj } from '../../../utils';

  // TODO: Translate component

  export default {
    mixins: [validationMixin],
    validations() {
      return {
        firstName: {
          required
        },
        lastName: {
          required
        },
        title: {
          required
        },
        email: {
          required,
          email
        },
        role: {
          required
        },
        business: this.isBusinessContact ? { required } : {},
        selectedCountries: !this.isBusinessContact ? { required } : {},
        language: {
          required
        },
        timezone: {
          required
        }
      };
    },
    props: {
      user: {
        type: Object,
        default: undefined
      },
      cancelTriggerLabel: {
        type: String,
        default: 'Cancel'
      },
      confirmTriggerLabel: {
        type: String,
        default: 'Create user'
      },
      submitTriggerIcon: {
        type: String,
        default: 'person_add'
      },
      isLoading: {
        type: Boolean,
        default: false
      },
      isDisabled: {
        type: Boolean,
        default: false
      },
      isCleared: {
        type: Boolean,
        default: true
      },
      onCancel: {
        type: Function,
        default: undefined
      },
      onSubmit: {
        type: Function,
        default: undefined
      },
    },
    data: () => ({
      firstName: '',
      lastName: '',
      title: '',
      email: '',
      role: {},
      business: {},
      businesses: [],
      selectedCountries: [],
      language: {},
      timezone: {},
      businessSearch: '',
      isSubmitted: false,
      isPasswordVisible: false,
      isLoadingBusinesses: false,
      colors
    }),
    computed: {
      roles() {
        return this.$store.getters['config/roles'];
      },
      country() {
        return this.$store.getters['config/country'];
      },
      countries() {
        return this.$store.getters['users/countries'];
      },
      languages() {
        return this.$store.getters['config/languages'];
      },
      timezones() {
        return this.$store.getters['config/timezones'];
      },
      hasCountry() {
        const { code = '' } = this.role;
        return code && code !== 'business_contact';
      },
      hasUser() {
        return isObj(this.user);
      },
      isBusinessContact() {
        const { code = '' } = this.role;
        return code === 'business_contact';
      },
      isSuperAdmin() {
        const { code = '' } = this.role;
        return code === 'super_admin';
      },
      firstNameErrors() {
        const errors = [];
        if (!this.$v.firstName.$dirty) {
          return errors;
        }
        if (!this.$v.firstName.required) {
          errors.push(router.app.$t('components.forms.user_profile.errors.first_name_required'));
        }
        return errors;
      },
      lastNameErrors() {
        const errors = [];
        if (!this.$v.lastName.$dirty) {
          return errors;
        }
        if (!this.$v.lastName.required) {
          errors.push(router.app.$t('components.forms.user_profile.errors.last_name_required'));
        }
        return errors;
      },
      titleErrors() {
        const errors = [];
        if (!this.$v.title.$dirty) {
          return errors;
        }
        if (!this.$v.title.required) {
          errors.push(router.app.$t('components.forms.user_profile.errors.title_required'));
        }
        return errors;
      },
      emailErrors() {
        const errors = [];
        if (!this.$v.email.$dirty) {
          return errors;
        }
        if (!this.$v.email.required) {
          errors.push(router.app.$t('components.forms.confirm_business.errors.email_required'));
        }
        if (!this.$v.email.email) {
          errors.push(router.app.$t('components.forms.confirm_business.errors.email_valid'));
        }
        return errors;
      },
      roleErrors() {
        const errors = [];
        if (!this.$v.role.$dirty) {
          return errors;
        }
        if (!this.$v.role.required) {
          errors.push('Role is required');
        }
        return errors;
      },
      businessErrors() {
        const errors = [];
        if (!this.$v.business.$dirty) {
          return errors;
        }
        if (!this.$v.business.required) {
          errors.push('Business is required');
        }
        return errors;
      },
      countryErrors() {
        const errors = [];
        if (!this.$v.selectedCountries.$dirty) {
          return errors;
        }
        if (!this.$v.selectedCountries.required) {
          errors.push('Country is required');
        }
        return errors;
      },
      languageErrors() {
        const errors = [];
        if (!this.$v.language.$dirty) {
          return errors;
        }
        if (!this.$v.language.required) {
          errors.push('Language is required');
        }
        return errors;
      },
      timezoneErrors() {
        const errors = [];
        if (!this.$v.timezone.$dirty) {
          return errors;
        }
        if (!this.$v.timezone.required) {
          errors.push('Timezone is required');
        }
        return errors;
      }
    },
    watch: {
      user(nextUser) {
        if (isObj(nextUser)) {
          const hasBusiness = isObj(nextUser.business);

          if (hasBusiness) {
            return this.getBusinesses(nextUser.business.name)
              .then(() => this.extractUserData(nextUser));
          }

          this.clear();
          this.extractUserData(nextUser);
        }
      },
      businessSearch(nextSearch) {
        if (isStr(nextSearch)) {
          this.getBusinesses(nextSearch);
        }
      },
      isOn(nextVal) {
        if (!nextVal) {
          this.clear();
        }
      }
    },
    created() {
      this.getBusinesses();

      this.$watch(() => {
        const hasErrors = this.$store.getters['alerts/error'].length > 0;

        if (hasErrors && this.isSubmitted) {
          this.isSubmitted = false;
        }
      });
    },
    methods: {
      cancel() {
        this.clear();
        this.onCancel();
      },
      submit() {
        this.$v.$touch();

        if (!this.canSubmitRequest() || this.$v.$error || this.$v.pending) {
          return false;
        }

        this.addUser();
      },
      clear() {
        this.$v.$reset();
        this.firstName = '';
        this.lastName = '';
        this.title = '';
        this.email = '';
        this.role = {};
        this.business = {};
        this.selectedCountries = [];
        this.language = {};
        this.timezone = {};
        this.isSubmitted = false;
        this.isPasswordVisible = false;
      },
      addUser() {
        const { firstName, lastName, email, title, role, business, selectedCountries, language, timezone, isBusinessContact } = this;

        const userProfile = {
          firstname: firstName,
          lastname: lastName,
          email,
          employee: title,
          role: role.code,
          language: language.code,
          timezone: timezone.code
        };

        if (isBusinessContact) {
          userProfile.business_id = business.id;
        }

        if (!isBusinessContact) {
          userProfile.country = selectedCountries.map((country) => country.code);
        }

        return this.onSubmit(userProfile)
          .then(() => {
            const hasErrors = this.$store.getters['alerts/error'].length > 0;
            if (hasErrors) {
              return false;
            }

            return this.clear();
          });
      },
      canSubmitRequest() {
        const { firstName, lastName, title, email, role, business, selectedCountries, language, timezone, isBusinessContact, isSubmitted } = this;

        return firstName !== ''
          && lastName !== ''
          && title !== ''
          && email !== ''
          && isStr(role.code)
          && (!isBusinessContact || (isBusinessContact && isNum(business.id)))
          && (isBusinessContact || (!isBusinessContact && selectedCountries.length > 0))
          && isStr(language.code)
          && isStr(timezone.code)
          && !isSubmitted;
      },
      customFilter(item, queryText) {
        const textOne = item.name.toLowerCase();
        const searchText = queryText.toLowerCase();

        return textOne.indexOf(searchText) > -1;
      },
      extractUserData(user) {
        const role = this.roles.find(role => role.code === user.role.slug);
        const business = this.businesses.find(business => business.id === user.business_id);
        const language = this.languages.find(language => language.code === user.language.code);
        const timezone = this.timezones.find(timezone => timezone.code === user.timezone);

        this.firstName = user.firstname;
        this.lastName = user.lastname;
        this.email = user.email;
        this.title = user.employee;
        this.role = role;
        this.business = business;
        this.selectedCountries = user.countries;
        this.language = language;
        this.timezone = timezone;
      },
      getBusinesses(search) {
        const query = {
          per_page: -1,
          search,
          target_country: this.country.code
        };

        this.isLoadingBusinesses = true;
        return this.$store.dispatch('businesses/getItems', query)
          .then(({ items }) => {
            this.businesses = items;
            this.isLoadingBusinesses = false;
            return items;
          })
          .catch((err) => {
            this.isLoadingBusinesses = false;
            return err;
          });
      }
    },
  };
</script>

<style lang="stylus" scoped>
  @import '../../../assets/stylus/theme.styl';

  [data-component-group="user-form"] {
    &[data-component="add-new"] {
      .form-actions {
        display: flex;
        justify-content: flex-end;
        align-items: center;

        .v-btn {
          border-radius: 4px;

          &.trigger {
            .v-icon {
              margin: 0 6px 0 0;
            }
          }

          &:last-child {
            margin-right: 0;
          }
        }
      }
    }
  }
</style>
